// Generated by purs version 0.11.6
"use strict";
var Control_Applicative = require("../Control.Applicative");
var Control_Bind = require("../Control.Bind");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Array = require("../Data.Array");
var Data_Eq = require("../Data.Eq");
var Data_Foldable = require("../Data.Foldable");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Data_List = require("../Data.List");
var Data_List_Types = require("../Data.List.Types");
var Data_Map = require("../Data.Map");
var Data_Maybe = require("../Data.Maybe");
var Data_Monoid = require("../Data.Monoid");
var Data_Ord = require("../Data.Ord");
var Data_Ordering = require("../Data.Ordering");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Set = require("../Data.Set");
var Data_String_Util = require("../Data.String.Util");
var Data_Tuple = require("../Data.Tuple");
var Doc = require("../Doc");
var IRGraph = require("../IRGraph");
var Options = require("../Options");
var Prelude = require("../Prelude");
var Utils = require("../Utils");
var singleWord = function (w) {
    return Control_Applicative.pure(Doc.applicativeDoc)({
        rendered: w, 
        multiWord: false
    });
};
var renderComment = function (v) {
    if (v instanceof Data_Maybe.Just) {
        return " -- " + v.value0;
    };
    if (v instanceof Data_Maybe.Nothing) {
        return "";
    };
    throw new Error("Failed pattern match at Language.Elm line 111, column 1 - line 111, column 40: " + [ v.constructor.name ]);
};
var parenIfNeeded = function (v) {
    if (!v.multiWord) {
        return v.rendered;
    };
    if (v.multiWord) {
        return "(" + (v.rendered + ")");
    };
    throw new Error("Failed pattern match at Language.Elm line 213, column 1 - line 213, column 72: " + [ v.constructor.name ]);
};
var multiWord = function (s1) {
    return function (s2) {
        return Control_Applicative.pure(Doc.applicativeDoc)({
            rendered: s1 + (" " + s2), 
            multiWord: true
        });
    };
};
var moduleOption = Options.stringOption("module")("Generated module name")("NAME")("QuickType");
var listOption = Options.enumOption("array-type")("Use Array or List")([ new Data_Tuple.Tuple("array", false), new Data_Tuple.Tuple("list", true) ]);
var renderArrayType = Control_Bind.bind(Doc.bindDoc)(Doc.getOptionValue(listOption))(function (v) {
    return Control_Applicative.pure(Doc.applicativeDoc)((function () {
        if (v) {
            return "List";
        };
        return "Array";
    })());
});
var typeStringForType = function (v) {
    if (v instanceof IRGraph.IRNoInformation) {
        return singleWord("FIXME_THIS_SHOULD_NOT_HAPPEN");
    };
    if (v instanceof IRGraph.IRAnyType) {
        return singleWord("Jdec.Value");
    };
    if (v instanceof IRGraph.IRNull) {
        return singleWord("()");
    };
    if (v instanceof IRGraph.IRInteger) {
        return singleWord("Int");
    };
    if (v instanceof IRGraph.IRDouble) {
        return singleWord("Float");
    };
    if (v instanceof IRGraph.IRBool) {
        return singleWord("Bool");
    };
    if (v instanceof IRGraph.IRString) {
        return singleWord("String");
    };
    if (v instanceof IRGraph.IRArray) {
        return Control_Bind.bind(Doc.bindDoc)(typeStringForType(v.value0))(function (v1) {
            return Control_Bind.bind(Doc.bindDoc)(renderArrayType)(function (v2) {
                return multiWord(v2)(parenIfNeeded(v1));
            });
        });
    };
    if (v instanceof IRGraph.IRClass) {
        return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Doc.lookupClassName(v.value0));
    };
    if (v instanceof IRGraph.IRMap) {
        return Control_Bind.bind(Doc.bindDoc)(typeStringForType(v.value0))(function (v1) {
            return multiWord("Dict String")(parenIfNeeded(v1));
        });
    };
    if (v instanceof IRGraph.IREnum) {
        return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Doc.lookupEnumName(v.value0));
    };
    if (v instanceof IRGraph.IRUnion) {
        var v1 = IRGraph.nullableFromUnion(v.value0);
        if (v1 instanceof Data_Maybe.Just) {
            return Control_Bind.bind(Doc.bindDoc)(typeStringForType(v1.value0))(function (v2) {
                return multiWord("Maybe")(parenIfNeeded(v2));
            });
        };
        if (v1 instanceof Data_Maybe.Nothing) {
            return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Doc.lookupUnionName(v.value0));
        };
        throw new Error("Failed pattern match at Language.Elm line 236, column 9 - line 241, column 45: " + [ v1.constructor.name ]);
    };
    throw new Error("Failed pattern match at Language.Elm line 218, column 21 - line 241, column 45: " + [ v.constructor.name ]);
};
var renderTopLevelDefinition = function (topLevelName) {
    return function (topLevel) {
        return Control_Bind.bind(Doc.bindDoc)(typeStringForType(topLevel))(function (v) {
            return Doc.line("type alias " + (topLevelName + (" = " + v.rendered)));
        });
    };
};
var legalize = Data_String_Util.legalizeCharacters(Data_String_Util.isLetterOrUnderscoreOrDigit);
var forbiddenNames = [ "if", "then", "else", "case", "of", "let", "in", "type", "module", "where", "import", "exposing", "as", "port", "int", "float", "bool", "string", "Jenc", "Jdec", "Jpipe", "always", "identity", "Array", "List", "Dict", "Maybe", "map", "toList", "makeArrayEncoder", "makeDictEncoder", "makeNullableEncoder" ];
var forWithPrefix_ = function (dictApplicative) {
    return function (l) {
        return function (firstPrefix) {
            return function (restPrefix) {
                return function (f) {
                    return Utils.forEnumerated_(dictApplicative)(l)(function (i) {
                        return f((function () {
                            var $76 = i === 0;
                            if ($76) {
                                return firstPrefix;
                            };
                            return restPrefix;
                        })());
                    });
                };
            };
        };
    };
};
var renderTypeDefinition = function (className) {
    return function (propertyNames) {
        return function (propsList) {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("type alias " + (className + " =")))(function () {
                return Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(forWithPrefix_(Doc.applicativeDoc)(propsList)("{ ")(", ")(function (braceOrComma) {
                    return function (v) {
                        var propName = Doc.lookupName(Data_Ord.ordString)(v.value0)(propertyNames);
                        return Control_Bind.bind(Doc.bindDoc)(typeStringForType(v.value1))(function (v1) {
                            return Doc.line(braceOrComma + (propName + (" : " + v1.rendered)));
                        });
                    };
                }))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Eq.eq(Data_List_Types.eqList(Data_Tuple.eqTuple(Data_Eq.eqString)(IRGraph.eqIRType)))(propsList)(Data_List_Types.Nil.value))(Doc.line("{")))(function () {
                        return Doc.line("}");
                    });
                }));
            });
        };
    };
};
var encoderNameFromTypeName = function (className) {
    return "encode" + className;
};
var encoderNameForType = function (v) {
    if (v instanceof IRGraph.IRNoInformation) {
        return singleWord("FIXME_THIS_SHOULD_NOT_HAPPEN");
    };
    if (v instanceof IRGraph.IRAnyType) {
        return singleWord("identity");
    };
    if (v instanceof IRGraph.IRNull) {
        return multiWord("always")("Jenc.null");
    };
    if (v instanceof IRGraph.IRInteger) {
        return singleWord("Jenc.int");
    };
    if (v instanceof IRGraph.IRDouble) {
        return singleWord("Jenc.float");
    };
    if (v instanceof IRGraph.IRBool) {
        return singleWord("Jenc.bool");
    };
    if (v instanceof IRGraph.IRString) {
        return singleWord("Jenc.string");
    };
    if (v instanceof IRGraph.IRArray) {
        return Control_Bind.bind(Doc.bindDoc)(encoderNameForType(v.value0))(function (v1) {
            return Control_Bind.bind(Doc.bindDoc)(renderArrayType)(function (v2) {
                return multiWord("make" + (v2 + "Encoder"))(parenIfNeeded(v1));
            });
        });
    };
    if (v instanceof IRGraph.IRClass) {
        return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Data_Functor.map(Doc.functorDoc)(encoderNameFromTypeName)(Doc.lookupClassName(v.value0)));
    };
    if (v instanceof IRGraph.IRMap) {
        return Control_Bind.bind(Doc.bindDoc)(encoderNameForType(v.value0))(function (v1) {
            return multiWord("makeDictEncoder")(parenIfNeeded(v1));
        });
    };
    if (v instanceof IRGraph.IREnum) {
        return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Data_Functor.map(Doc.functorDoc)(encoderNameFromTypeName)(Doc.lookupEnumName(v.value0)));
    };
    if (v instanceof IRGraph.IRUnion) {
        var v1 = IRGraph.nullableFromUnion(v.value0);
        if (v1 instanceof Data_Maybe.Just) {
            return Control_Bind.bind(Doc.bindDoc)(encoderNameForType(v1.value0))(function (v2) {
                return multiWord("makeNullableEncoder")(parenIfNeeded(v2));
            });
        };
        if (v1 instanceof Data_Maybe.Nothing) {
            return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Data_Functor.map(Doc.functorDoc)(encoderNameFromTypeName)(Doc.lookupUnionName(v.value0)));
        };
        throw new Error("Failed pattern match at Language.Elm line 293, column 9 - line 298, column 73: " + [ v1.constructor.name ]);
    };
    throw new Error("Failed pattern match at Language.Elm line 275, column 22 - line 298, column 73: " + [ v.constructor.name ]);
};
var elmNameStyle = function (upper) {
    return function ($150) {
        return Data_String_Util.startWithLetter(Data_String_Util.isLetterOrUnderscore)(upper)(Data_String_Util.camelCase(legalize($150)));
    };
};
var lowerNameStyle = elmNameStyle(false);
var typeRenderer = function (renderer$prime) {
    return function (className) {
        return function (properties) {
            var propertyNames = Doc.transformPropertyNames(Doc.simpleNamer(Data_Ord.ordString)(lowerNameStyle))(function (n) {
                return "other" + Data_String_Util.capitalize(n);
            })(forbiddenNames)(properties);
            var propsList = Utils.sortByKey(Data_Ord.ordString)(function (t) {
                return Doc.lookupName(Data_Ord.ordString)(Data_Tuple.fst(t))(propertyNames);
            })(Data_Map.toUnfoldable(Data_List_Types.unfoldableList)(properties));
            return renderer$prime(className)(propertyNames)(propsList);
        };
    };
};
var upperNameStyle = elmNameStyle(true);
var nameForClass = function (v) {
    return upperNameStyle(Doc.combineNames(v.names));
};
var typeNameForTopLevelNameGiven = upperNameStyle;
var unionConstructorName = function (unionName) {
    return function (t) {
        return Control_Bind.bind(Doc.bindDoc)(Data_Functor.map(Doc.functorDoc)(upperNameStyle)(Doc.getTypeNameForUnion(t)))(function (v) {
            return Control_Applicative.pure(Doc.applicativeDoc)(v + ("In" + unionName));
        });
    };
};
var renderUnionDefinition = function (unionName) {
    return function (unionRep) {
        return Control_Bind.bind(Doc.bindDoc)(Utils.sortByKeyM(Data_Ord.ordString)(Doc.monadDoc)(unionConstructorName(unionName))(IRGraph.unionToList(unionRep)))(function (v) {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("type " + unionName))(function () {
                return forWithPrefix_(Doc.applicativeDoc)(v)("=")("|")(function (equalsOrPipe) {
                    return function (t) {
                        return Doc.indent(Control_Bind.bind(Doc.bindDoc)(unionConstructorName(unionName)(t))(function (v1) {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Eq.eq(IRGraph.eqIRType)(t)(IRGraph.IRNull.value))(Doc.line(equalsOrPipe + (" " + v1))))(function () {
                                return Control_Applicative.unless(Doc.applicativeDoc)(Data_Eq.eq(IRGraph.eqIRType)(t)(IRGraph.IRNull.value))(Control_Bind.bind(Doc.bindDoc)(typeStringForType(t))(function (v2) {
                                    return Doc.line(equalsOrPipe + (" " + (v1 + (" " + parenIfNeeded(v2)))));
                                }));
                            });
                        }));
                    };
                });
            });
        });
    };
};
var decoderNameFromTypeName = Data_String_Util.decapitalize;
var decoderNameForType = function (v) {
    if (v instanceof IRGraph.IRNoInformation) {
        return singleWord("FIXME_THIS_SHOULD_NOT_HAPPEN");
    };
    if (v instanceof IRGraph.IRAnyType) {
        return singleWord("Jdec.value");
    };
    if (v instanceof IRGraph.IRNull) {
        return multiWord("Jdec.null")("()");
    };
    if (v instanceof IRGraph.IRInteger) {
        return singleWord("Jdec.int");
    };
    if (v instanceof IRGraph.IRDouble) {
        return singleWord("Jdec.float");
    };
    if (v instanceof IRGraph.IRBool) {
        return singleWord("Jdec.bool");
    };
    if (v instanceof IRGraph.IRString) {
        return singleWord("Jdec.string");
    };
    if (v instanceof IRGraph.IRArray) {
        return Control_Bind.bind(Doc.bindDoc)(decoderNameForType(v.value0))(function (v1) {
            return Control_Bind.bind(Doc.bindDoc)(renderArrayType)(function (v2) {
                return multiWord("Jdec." + Data_String_Util.decapitalize(v2))(parenIfNeeded(v1));
            });
        });
    };
    if (v instanceof IRGraph.IRClass) {
        return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Data_Functor.map(Doc.functorDoc)(decoderNameFromTypeName)(Doc.lookupClassName(v.value0)));
    };
    if (v instanceof IRGraph.IRMap) {
        return Control_Bind.bind(Doc.bindDoc)(decoderNameForType(v.value0))(function (v1) {
            return multiWord("Jdec.dict")(parenIfNeeded(v1));
        });
    };
    if (v instanceof IRGraph.IREnum) {
        return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Data_Functor.map(Doc.functorDoc)(decoderNameFromTypeName)(Doc.lookupEnumName(v.value0)));
    };
    if (v instanceof IRGraph.IRUnion) {
        var v1 = IRGraph.nullableFromUnion(v.value0);
        if (v1 instanceof Data_Maybe.Just) {
            return Control_Bind.bind(Doc.bindDoc)(decoderNameForType(v1.value0))(function (v2) {
                return multiWord("Jdec.nullable")(parenIfNeeded(v2));
            });
        };
        if (v1 instanceof Data_Maybe.Nothing) {
            return Control_Bind.bindFlipped(Doc.bindDoc)(singleWord)(Data_Functor.map(Doc.functorDoc)(decoderNameFromTypeName)(Doc.lookupUnionName(v.value0)));
        };
        throw new Error("Failed pattern match at Language.Elm line 267, column 9 - line 272, column 73: " + [ v1.constructor.name ]);
    };
    throw new Error("Failed pattern match at Language.Elm line 249, column 22 - line 272, column 73: " + [ v.constructor.name ]);
};
var renderTopLevelFunctions = function (topLevelName) {
    return function (topLevel) {
        var topLevelDecoder = decoderNameFromTypeName(topLevelName);
        var topLevelEncoder = encoderNameFromTypeName(topLevelName);
        return Control_Bind.bind(Doc.bindDoc)(decoderNameForType(topLevel))(function (v) {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(topLevelDecoder + (" : Jdec.Decoder " + topLevelName)))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(topLevelDecoder + (" = " + v.rendered)))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                        return Control_Bind.bind(Doc.bindDoc)(encoderNameForType(topLevel))(function (v1) {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(topLevelEncoder + (" : " + (topLevelName + " -> String"))))(function () {
                                return Doc.line(topLevelEncoder + (" r = Jenc.encode 0 (" + (v1.rendered + " r)")));
                            });
                        });
                    });
                });
            });
        });
    };
};
var renderTypeFunctions = function (className) {
    return function (propertyNames) {
        return function (propsList) {
            var required = {
                reqOrOpt: "Jpipe.required", 
                fallback: ""
            };
            var optional = function (fallback) {
                return {
                    reqOrOpt: "Jpipe.optional", 
                    fallback: fallback
                };
            };
            var requiredOrOptional = function (v) {
                if (v instanceof IRGraph.IRNull) {
                    return optional(" ()");
                };
                if (v instanceof IRGraph.IRUnion) {
                    var $117 = !Doc.unionIsNotSimpleNullable(v.value0);
                    if ($117) {
                        return optional(" Nothing");
                    };
                    return required;
                };
                return required;
            };
            var decoderName = decoderNameFromTypeName(className);
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(decoderName + (" : Jdec.Decoder " + className)))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(decoderName + " ="))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("Jpipe.decode " + className))(function () {
                        return Data_Foldable.for_(Doc.applicativeDoc)(Data_List_Types.foldableList)(propsList)(function (v) {
                            return Doc.indent(Control_Bind.bind(Doc.bindDoc)(decoderNameForType(v.value1))(function (v1) {
                                var v2 = requiredOrOptional(v.value1);
                                return Doc.line("|> " + (v2.reqOrOpt + (" \"" + (Data_String_Util.stringEscape(v.value0) + ("\" " + (parenIfNeeded(v1) + v2.fallback))))));
                            }));
                        });
                    })))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                            var encoderName = encoderNameFromTypeName(className);
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(encoderName + (" : " + (className + " -> Jenc.Value"))))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(encoderName + " x ="))(function () {
                                    return Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("Jenc.object"))(function () {
                                        return Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(forWithPrefix_(Doc.applicativeDoc)(propsList)("[ ")(", ")(function (bracketOrComma) {
                                            return function (v) {
                                                var propName = Doc.lookupName(Data_Ord.ordString)(v.value0)(propertyNames);
                                                return Control_Bind.bind(Doc.bindDoc)(encoderNameForType(v.value1))(function (v1) {
                                                    return Doc.line(bracketOrComma + ("(\"" + (Data_String_Util.stringEscape(v.value0) + ("\", " + (v1.rendered + (" x." + (propName + ")")))))));
                                                });
                                            };
                                        }))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Eq.eq(Data_List_Types.eqList(Data_Tuple.eqTuple(Data_Eq.eqString)(IRGraph.eqIRType)))(propsList)(Data_List_Types.Nil.value))(Doc.line("[")))(function () {
                                                return Doc.line("]");
                                            });
                                        }));
                                    }));
                                });
                            });
                        });
                    });
                });
            });
        };
    };
};
var renderUnionFunctions = function (unionName) {
    return function (unionRep) {
        var arrayFirstOrder = function (a) {
            return function (b) {
                var $131 = IRGraph.isArray(a);
                if ($131) {
                    var $132 = IRGraph.isArray(b);
                    if ($132) {
                        return Data_Ord.compare(IRGraph.ordIRType)(a)(b);
                    };
                    return Data_Ordering.LT.value;
                };
                var $133 = IRGraph.isArray(b);
                if ($133) {
                    return Data_Ordering.GT.value;
                };
                return Data_Ord.compare(IRGraph.ordIRType)(a)(b);
            };
        };
        var decoderName = decoderNameFromTypeName(unionName);
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(decoderName + (" : Jdec.Decoder " + unionName)))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(decoderName + " ="))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent((function () {
                    var decFields = Data_List.sortBy(arrayFirstOrder)(IRGraph.unionToList(unionRep));
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("Jdec.oneOf"))(function () {
                        return Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(forWithPrefix_(Doc.applicativeDoc)(decFields)("[")(",")(function (bracketOrComma) {
                            return function (t) {
                                return Control_Bind.bind(Doc.bindDoc)(unionConstructorName(unionName)(t))(function (v) {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Eq.eq(IRGraph.eqIRType)(t)(IRGraph.IRNull.value))(Doc.line(bracketOrComma + (" Jdec.null " + v))))(function () {
                                        return Control_Applicative.unless(Doc.applicativeDoc)(Data_Eq.eq(IRGraph.eqIRType)(t)(IRGraph.IRNull.value))(Control_Bind.bind(Doc.bindDoc)(decoderNameForType(t))(function (v1) {
                                            return Doc.line(bracketOrComma + (" Jdec.map " + (v + (" " + parenIfNeeded(v1)))));
                                        }));
                                    });
                                });
                            };
                        }))(function () {
                            return Doc.line("]");
                        }));
                    });
                })()))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                        var encoderName = encoderNameFromTypeName(unionName);
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(encoderName + (" : " + (unionName + " -> Jenc.Value"))))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(encoderName + " x = case x of"))(function () {
                                return Doc.indent(Control_Bind.bind(Doc.bindDoc)(Utils.sortByKeyM(Data_Ord.ordString)(Doc.monadDoc)(unionConstructorName(unionName))(IRGraph.unionToList(unionRep)))(function (v) {
                                    return Data_Foldable.for_(Doc.applicativeDoc)(Data_List_Types.foldableList)(v)(function (t) {
                                        return Control_Bind.bind(Doc.bindDoc)(unionConstructorName(unionName)(t))(function (v1) {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Eq.eq(IRGraph.eqIRType)(t)(IRGraph.IRNull.value))(Doc.line(v1 + " -> Jenc.null")))(function () {
                                                return Control_Applicative.unless(Doc.applicativeDoc)(Data_Eq.eq(IRGraph.eqIRType)(t)(IRGraph.IRNull.value))(Control_Bind.bind(Doc.bindDoc)(encoderNameForType(t))(function (v2) {
                                                    return Doc.line(v1 + (" y -> " + (v2.rendered + " y")));
                                                }));
                                            });
                                        });
                                    });
                                }));
                            });
                        });
                    });
                });
            });
        });
    };
};
var alsoForbiddenForTypeName = function (n) {
    return [ decoderNameFromTypeName(n), encoderNameFromTypeName(n) ];
};
var elmDoc = Control_Bind.bind(Doc.bindDoc)(Doc.getTopLevels)(function (v) {
    return Control_Bind.bind(Doc.bindDoc)(Doc.getClasses)(function (v1) {
        return Control_Bind.bind(Doc.bindDoc)(Doc.getUnions)(function (v2) {
            return Control_Bind.bind(Doc.bindDoc)(Utils.mapM(Doc.applicativeDoc)(Data_List_Types.traversableList)(function (t) {
                return Doc.lookupClassName(Data_Tuple.fst(t));
            })(v1))(function (v3) {
                return Control_Bind.bind(Doc.bindDoc)(Data_Functor.map(Doc.functorDoc)(Data_Functor.map(Data_List_Types.functorList)(function (n) {
                    return n + "(..)";
                }))(Utils.mapM(Doc.applicativeDoc)(Data_List_Types.traversableList)(Doc.lookupUnionName)(v2)))(function (v4) {
                    return Control_Bind.bind(Doc.bindDoc)(Data_Functor.map(Doc.functorDoc)(Data_Map.values)(Doc.getTopLevelNames))(function (v5) {
                        var topLevelDecoders = Data_Functor.map(Data_List_Types.functorList)(decoderNameFromTypeName)(v5);
                        var alsoTopLevelExports = Data_List.concat(Data_Functor.map(Data_List_Types.functorList)(function ($151) {
                            return Data_List.fromFoldable(Data_Foldable.foldableArray)(alsoForbiddenForTypeName($151));
                        })(v5));
                        var exports = Data_List.concat(new Data_List_Types.Cons(v5, new Data_List_Types.Cons(alsoTopLevelExports, new Data_List_Types.Cons(v3, new Data_List_Types.Cons(v4, Data_List_Types.Nil.value)))));
                        return Control_Bind.bind(Doc.bindDoc)(Doc.getOptionValue(moduleOption))(function (v6) {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("-- To decode the JSON data, add this file to your project, run\x0a--\x0a--     elm-package install NoRedInk/elm-decode-pipeline\x0a--\x0a-- add these imports\x0a--\x0a--     import Json.Decode exposing (decodeString)"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("--     import " + (v6 + (" exposing (" + (Data_Foldable.intercalate(Data_List_Types.foldableList)(Data_Monoid.monoidString)(", ")(topLevelDecoders) + ")")))))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("--\x0a-- and you're off to the races with\x0a--"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachTopLevel_(function (topLevelName) {
                                            return function (topLevelType) {
                                                var topLevelDecoder = decoderNameFromTypeName(topLevelName);
                                                return Doc.line("--     decodeString " + (topLevelDecoder + " myJsonString"));
                                            };
                                        }))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("module " + (v6 + " exposing")))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(forWithPrefix_(Doc.applicativeDoc)(exports)("( ")(", ")(function (parenOrComma) {
                                                        return function (name) {
                                                            return Doc.line(parenOrComma + name);
                                                        };
                                                    }))(function () {
                                                        return Doc.line(")");
                                                    })))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("import Json.Decode as Jdec\x0aimport Json.Decode.Pipeline as Jpipe\x0aimport Json.Encode as Jenc\x0aimport Dict exposing (Dict, map, toList)"))(function () {
                                                                return Control_Bind.bind(Doc.bindDoc)(renderArrayType)(function (v7) {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.whenOption(listOption)(Doc.line("import List exposing (map)")))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.unlessOption(listOption)(Doc.line("import Array exposing (Array, map)")))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.renderRenderItems(Doc.blank)(new Data_Maybe.Just(renderTopLevelDefinition))(typeRenderer(renderTypeDefinition))(new Data_Maybe.Just(renderUnionDefinition))(Data_Maybe.Nothing.value))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("-- decoders and encoders"))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.renderRenderItems(Doc.blank)(new Data_Maybe.Just(renderTopLevelFunctions))(typeRenderer(renderTypeFunctions))(new Data_Maybe.Just(renderUnionFunctions))(Data_Maybe.Nothing.value))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("--- encoder helpers"))(function () {
                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("make" + (v7 + ("Encoder : (a -> Jenc.Value) -> " + (v7 + " a -> Jenc.Value")))))(function () {
                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("make" + (v7 + "Encoder f arr =")))(function () {
                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Doc.line("Jenc." + (Data_String_Util.decapitalize(v7) + (" (" + (v7 + ".map f arr)"))))))(function () {
                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                                                                return Doc.line("makeDictEncoder : (a -> Jenc.Value) -> Dict String a -> Jenc.Value\x0amakeDictEncoder f dict =\x0a    Jenc.object (toList (Dict.map (\\k -> f) dict))\x0a\x0amakeNullableEncoder : (a -> Jenc.Value) -> Maybe a -> Jenc.Value\x0amakeNullableEncoder f m =\x0a    case m of\x0a    Just x -> f x\x0a    Nothing -> Jenc.null");
                                                                                                                            });
                                                                                                                        });
                                                                                                                    });
                                                                                                                });
                                                                                                            });
                                                                                                        });
                                                                                                    });
                                                                                                });
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    });
});
var elmNamer = function (dictOrd) {
    return function (namer) {
        return function (thing) {
            var result = function (name) {
                return {
                    name: name, 
                    forbid: Data_Array.cons(name)(alsoForbiddenForTypeName(name))
                };
            };
            return function (v) {
                if (v instanceof Data_Maybe.Just) {
                    return result(v.value0);
                };
                if (v instanceof Data_Maybe.Nothing) {
                    return result(namer(thing));
                };
                throw new Error("Failed pattern match at Language.Elm line 82, column 24 - line 84, column 36: " + [ v.constructor.name ]);
            };
        };
    };
};
var renderer = {
    displayName: "Elm", 
    names: [ "elm" ], 
    aceMode: "elm", 
    extension: "elm", 
    doc: elmDoc, 
    options: [ moduleOption.specification, listOption.specification ], 
    transforms: {
        nameForClass: elmNamer(IRGraph.ordIRClassData)(nameForClass), 
        nextName: function (s) {
            return "Other" + s;
        }, 
        forbiddenNames: forbiddenNames, 
        topLevelName: elmNamer(Data_Ord.ordString)(upperNameStyle), 
        unions: new Data_Maybe.Just({
            predicate: Doc.unionIsNotSimpleNullable, 
            properName: elmNamer(IRGraph.ordNamed(Data_Set.ordSet(Data_Ord.ordString)))(function ($152) {
                return upperNameStyle(Doc.combineNames($152));
            }), 
            nameFromTypes: elmNamer(Data_Ord.ordArray(Data_Ord.ordString))(Doc.intercalatedName(upperNameStyle)("Or"))
        }), 
        enums: new Data_Maybe.Just({
            properName: elmNamer(IRGraph.ordNamed(Data_Set.ordSet(Data_Ord.ordString)))(function ($153) {
                return upperNameStyle(Doc.combineNames($153));
            }), 
            nameFromValues: elmNamer(Data_Ord.ordArray(Data_Ord.ordString))(Doc.intercalatedName(upperNameStyle)("Or"))
        })
    }
};
var namesFromTopLevelNameGiven = function (given) {
    var name = typeNameForTopLevelNameGiven(given);
    return Data_Array.cons(name)(alsoForbiddenForTypeName(name));
};
module.exports = {
    renderer: renderer
};
//# sourceMappingURL=index.js.map
