// Generated by purs version 0.11.6
"use strict";
var Config = require("../Config");
var Control_Applicative = require("../Control.Applicative");
var Control_Bind = require("../Control.Bind");
var Control_Monad_Except_Trans = require("../Control.Monad.Except.Trans");
var Control_Monad_State = require("../Control.Monad.State");
var Control_Monad_State_Class = require("../Control.Monad.State.Class");
var Control_Monad_State_Trans = require("../Control.Monad.State.Trans");
var Core = require("../Core");
var Data_Argonaut_Core = require("../Data.Argonaut.Core");
var Data_Argonaut_Decode = require("../Data.Argonaut.Decode");
var Data_Argonaut_Decode_Class = require("../Data.Argonaut.Decode.Class");
var Data_Either = require("../Data.Either");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_Identity = require("../Data.Identity");
var Data_Maybe = require("../Data.Maybe");
var Data_Ord = require("../Data.Ord");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Set = require("../Data.Set");
var Data_StrMap = require("../Data.StrMap");
var Data_Unit = require("../Data.Unit");
var Doc = require("../Doc");
var IR = require("../IR");
var IRGraph = require("../IRGraph");
var IRTypeable = require("../IRTypeable");
var Options = require("../Options");
var Prelude = require("../Prelude");
var Reykjavik = require("../Reykjavik");
var Transformations = require("../Transformations");
var UrlGrammar = require("../UrlGrammar");
var urlsFromJsonGrammar = function (json) {
    return Control_Bind.bind(Data_Either.bindEither)(Data_Argonaut_Decode_Class.decodeJson(UrlGrammar.decodeGrammarMap)(json))(function (v) {
        return Control_Applicative.pure(Data_Either.applicativeEither)(Data_Functor.map(Data_StrMap.functorStrMap)(UrlGrammar.generate)(v));
    });
};
var intSentinel = IRTypeable.intSentinel;
var graphFromConfig = function (config) {
    var samples = Config.topLevelSamples(config);
    var schemas = Config.topLevelSchemas(config);
    return Control_Bind.bind(Data_Either.bindEither)(Data_Functor.map(Data_Either.functorEither)(IR.normalizeGraphOrder)(IR.execIR(Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(IRTypeable.makeTypes(IRTypeable.typeableTypeSource)(samples))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Transformations.replaceSimilarClasses)(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))((function () {
                var $8 = Config.inferMaps(config);
                if ($8) {
                    return Transformations.makeMaps;
                };
                return Control_Applicative.pure(Control_Monad_Except_Trans.applicativeExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Unit.unit);
            })())(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.modify(Control_Monad_Except_Trans.monadStateExceptT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity)))(IRGraph.regatherClassNames))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(IRTypeable.makeTypes(IRTypeable.typeableJSONSchema)(schemas))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.modify(Control_Monad_Except_Trans.monadStateExceptT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity)))(IRGraph.regatherUnionNames))(function () {
                            return IR.replaceNoInformationWithAnyType;
                        });
                    });
                });
            });
        });
    }))))(function (v) {
        return Control_Applicative.pure(Data_Either.applicativeEither)(v);
    });
};
var glueGraphFromJsonConfig = function (json) {
    return Control_Bind.bind(Data_Either.bindEither)(Config.parseConfig(json))(function (v) {
        return Control_Bind.bind(Data_Either.bindEither)(graphFromConfig(v))(function (v1) {
            return Control_Applicative.pure(Data_Either.applicativeEither)(Reykjavik.irGraphToGlue(v1));
        });
    });
};
var failOnEnum = function (graph) {
    return function (language) {
        var set = IRGraph.filterTypes(Data_Set.ordSet(Data_Ord.ordUnit))(function (t) {
            var $12 = IRGraph.isEnum(t);
            if ($12) {
                return Data_Maybe.Just.create(Data_Set.singleton(Data_Unit.unit));
            };
            return Data_Maybe.Nothing.value;
        })(graph);
        var $13 = Data_Set.isEmpty(set);
        if ($13) {
            return new Data_Either.Right(Data_Unit.unit);
        };
        return new Data_Either.Left("Enums are not supported in " + (language + " yet."));
    };
};
var main = function (json) {
    return Control_Bind.bind(Data_Either.bindEither)(Config.parseConfig(json))(function (v) {
        return Control_Bind.bind(Data_Either.bindEither)(graphFromConfig(v))(function (v1) {
            return Control_Bind.bind(Data_Either.bindEither)(Config.renderer(v))(function (v2) {
                return Control_Bind.discard(Control_Bind.discardUnit)(Data_Either.bindEither)(failOnEnum(v1)(v2.displayName))(function () {
                    var optionStrings = Config.rendererOptions(v);
                    var optionValues = Options.makeOptionValues(v2.options)(optionStrings);
                    return Control_Applicative.pure(Data_Either.applicativeEither)(Doc.runRenderer(v2)(v1)(optionValues));
                });
            });
        });
    });
};
module.exports = {
    glueGraphFromJsonConfig: glueGraphFromJsonConfig, 
    intSentinel: intSentinel, 
    main: main, 
    urlsFromJsonGrammar: urlsFromJsonGrammar
};
//# sourceMappingURL=index.js.map
