import { Config } from "./Config"
import { Renderer } from "./Doc"
import { TopLevels } from "./Type";
import { RenderResult } from "./Renderer";
import { OptionDefinition } from "./RendererOptions";
import { SerializedRenderResult } from "./Source";
export declare abstract class TargetLanguage {
    readonly displayName: string;
    readonly names: string[];
    readonly extension: string;
    readonly optionDefinitions: OptionDefinition[];
    constructor(displayName: string, names: string[], extension: string, optionDefinitions: OptionDefinition[]);
    abstract transformAndRenderConfig(config: Config): SerializedRenderResult;
}
export declare abstract class TypeScriptTargetLanguage extends TargetLanguage {
    transformAndRenderConfig(config: Config): SerializedRenderResult;
    protected readonly indentation: string;
    protected abstract renderGraph(topLevels: TopLevels, optionValues: {
        [name: string]: any;
    }): RenderResult;
}
export declare class PureScriptTargetLanguage extends TargetLanguage {
    constructor(renderer: Renderer);
    transformAndRenderConfig(config: Config): SerializedRenderResult;
}
